'-------------------------------------------------------------------------------------------

'                                               

'                LCD  . Nokia-3310  Nokia-5110
'                 BASCOM-AVR 2.0.7.1; 2.0.7.3; 2.0.7.6
'                "glcd-Nokia3310.lib"    LCD
'                    (Mrshilov)  2013
'            (Sasha_1973)  2013

'-------------------------------------------------------------------------------------------
  $regfile = "m8def.dat"                          '  
  $crystal = 1000000                              ' 2000000  ' 4000000  ' 8000000
  $framesize = 32
  $hwstack = 40
  $swstack = 16
  $baud = 4800                                    '1200     '2400     '4800     '9600     '19200     '38400     '57600     '115000
'----------------     ----------------------------------------
  $lib "mcsbyte.lbx"
  $lib "glcd-Nokia3310.lib"
'----------------   LCD Nokia3310  Nokia5110  -------------------
  Config Graphlcd = 128 * 64eadogm , Cs1 = Portd.4 , A0 = Portd.5 , Si = Portd.6 , Sclk = Portd.7 , Rst = Portd.3
  Const Negative_lcd = 0                          '    ,  "Negative_lcd = 1"
  Initlcd                                         '  LCD
  Cls                                             '  LCD
'----------------        ------------------------------
'  Glcdcmd 12                                        '   
'  Glcdcmd 13                                        '   
'----------------------      --------------------------------
'  Setfont Font6x8
'  Setfont Font12x16dig
'-------------    TIMER2,    ( ) -----------------
'  Config Timer2 = Timer , Async = On , Prescale = 64       '  32768 / 64 / 256 = 0,5  ( TIMER2 = 2   )
'  Const __timer2 = 2
'---------------------------------------------------------------
  Config Timer2 = Timer , Async = On , Prescale = 128       '  32768 / 128 / 256 = 1  ( TIMER2 = 1   )
  Const __timer2 = 1        '      "__timer2"
'      TIMER2,   
  On Timer2 __timer2 Nosave    '      TIMER2
'---------------       ---------------
  Assr.3 = 1 : Waitms 100                         '  - AS2     
'      AS2 (3)   ASSR (ASSR.3),    
' "Powersave" -   .    TIMER2
'  Mcucr = &B10000000                              '      Power Idle
  Mcucr = &B10110000                              '      Power Save
'-------------------    INT0,    -------------------
'  Config Int0 = Low Level
'      INT0,    
'  On Int0 __int0
'----------------------------------------
'  __int0 Alias Pind.2
'  Config __int0 = Input
'  Set __int0
'-------------------------------------------------------------------------------------------

'------------------------------   USART  -------------------------------------
  Config Pind.0 = Input                           '   RxD,  UART
  Config Pind.1 = Output                          '   TxD,  UART
'-----------------------     --------------------------------
  Dim  As Byte
  Dim  As Byte
  Dim  As Byte
  Dim _string As String * 2
  Dim _string As String * 2
  Dim _string As String * 2
  Dim __ As Byte
  Dim __timer2 As Byte
  Dim ___ As Byte
  Dim ____usart As Byte
  Dim ___ As Byte
  Dim ___ As Byte
'-----------------------     -----------------------------
  Declare Sub __lcd()
  Declare Sub _uart()
  Declare Sub __()
  Declare Sub __timer2()
'------------------------     -----------------------------
   = 14
   = 3
   = 0
'-------------------      USART  ----------------------
  Print " "
  Print  ; ":" ;  ; ":" ;  : Print
  Wait 1
'--------------------       --------------------
'  Enable Timer0
'  Enable Timer1
  Enable Timer2
'--------------------       ------------------------
  Enable Interrupts
'-------------------------------------------------------------------------------------------
'****************************************************************
'------------------------------     -----------------------------------------
  Do
'-----------------------



      If __ = 1 Then Gosub __lcd

      If ____usart = 1 Then Gosub _uart



'-----------------------
    _:
'      Power Idle
      Power Powersave
'-----------------------
  Loop
 End
'-------------------------------------------------------------------------------------------
'****************************************************************

'=================================================

'                                         

'=================================================


'=================================================
'       LCD  . Nokia-3310  Nokia-5110
'=================================================
'-------------------------------------------------------------------------------------------
  __lcd:
'-------------------------------------------------------------------------------------------
    _string = Str()
    If  < 10 Then _string = " " + _string

    _string = Str()
    If  < 10 Then _string = "0" + _string

    _string = Str()
    If  < 10 Then _string = "0" + _string

    Setfont Font6x8
    Lcdat 1 , 1 , "  "
    Lcdat 4 , 70 , _string
    Lcdat 6 , 1 , "Nokia3310_5510"

    Setfont Font12x16dig
    Lcdat 3 , 5 , _string ; ":" ; _string       '; ":" ; 

    __ = 0
'-------------------------------------------------------------------------------------------
  Return
'=================================================



'=================================================
'    TIMER2,  1  2   ,     TIMER2
'=================================================
  __timer2:
'-------------------------------------------------------------------------------------------
     $asm
'-------------------------------------------------------------------------------------------
'----   ,     
'-------------------------------------------------------------------------------------------
      Push R31                                    '  ,     
      In R31 , Sreg
      Push R31
'-------------------------------------------------------------------------------------------
'------------------     TIMER2  --------------------
'-------------------------------------------------------------------------------------------
      Lds R31 , {__timer2}       '    "__timer2"   "R31",   
      Inc R31                                     '      "R31"
      sts {__timer2} , R31       '     "R31"   "__timer2"
'------------------
      Andi R31 , __timer2   '      "Const __timer2"
'------------------
      Breq __timer2                '      "Const __timer2",    "__timer2" -- 
      clr R31                                     '      "Const __timer2",  "0"   "R31
      sts {__timer2} , R31       '     "R31"   "__timer2"      
'-------------------------------------------------------------------------------------------
'--------     2  TIMER2  -------
'-------------------------------------------------------------------------------------------
      rcall __               '     
'-------------------------------------------------------------------------------------------
'---------------       ---------------
'-------------------------------------------------------------------------------------------
     __timer2:
      Pop R31
      Out Sreg , R31                              '  
      Pop R31
    $end Asm
'-------------------------------------------------------------------------------
  Return
'=================================================




'=================================================
'-----------    : ,     ---------
'=================================================
  __:
'-------------------------------------------------------------------------------------------
    Incr                                   '  

    If  > 59 Then                          '  
         = 0 : Goto _        '       
    End If

    Goto _
'----------------------------------------------------
   _:
'----------------------------------------------------
    Incr                                    '  

    If  > 59 Then                           '  
         = 0 : Goto _           '       
    End If

      Goto _
'----------------------------------------------------
    _:
'----------------------------------------------------
      Incr                                    '  

      If  > 23 Then                           '  
           = 0                                '   
      End If
'----------------------------------------------------
    _:
'----------------------------------------------------
      ____usart = 1
      ___ = 0
      __ = 1                 '  ,    
'-------------------------------------------------------------------------------------------
   ___:
'-------------------------------------------------------------------------------------------
  Return
'=================================================

'=================================================
'---       ( USART)
'=================================================
  _uart:
'-------------------------------------------------------------------------------------------
    Print "  - " ;
    Print  ; ":" ;
    If  < 10 Then Print "0" ;
    Print  ; ":";
    If  < 10 Then Print "0" ;
    Print 
    Print ""

    ____usart = 0
'-------------------------------------------------------------------------------------------
  Return
'=================================================



'----------     --------------
  $include "font6x8.font"
  $include "font12x16dig.font"
